"""
Module implement different usefull functions
"""
from typing import Generator


def lineProtocolFieldsGenerator(fields: dict) -> Generator:
    """
    Convert field value to influx line protocol format

    Args:
        fields: dict with values to convert

    Retruns:
        generator of fields
    """
    resStr = ""
    for field, value in fields.items():
        if value is None:
            continue

        if isinstance(value, float):
            resStr = f"{field}={value}"
        elif isinstance(value, bool):
            resStr = f"{field}={value}"
        elif isinstance(value, int):
            resStr = f"{field}={value}i"
        elif isinstance(value, str):
            resStr = f'{field}="{value}"'
        else:
            raise ValueError(f'Type: "{type(value)}" of field: "{field}" is not supported.')
        yield resStr
